Index: drivers/filesystems/btrfs/create.c
===================================================================
--- drivers/filesystems/btrfs/create.c	(révision 75772)
+++ drivers/filesystems/btrfs/create.c	(copie de travail)
@@ -1212,33 +1072,33 @@
             fcb->Header.AllocationSize.QuadPart = fcb->inode_item.st_size;
         else
             fcb->Header.AllocationSize.QuadPart = sector_align(fcb->inode_item.st_size, fcb->Vcb->superblock.sector_size);
-        
+
         fcb->Header.FileSize.QuadPart = fcb->inode_item.st_size;
         fcb->Header.ValidDataLength.QuadPart = fcb->inode_item.st_size;
     }
-    
+
     if (!atts_set)
-        fcb->atts = get_file_attributes(Vcb, &fcb->inode_item, fcb->subvol, fcb->inode, fcb->type, utf8 && utf8->Buffer[0] == '.', TRUE, Irp);
-    
+        fcb->atts = get_file_attributes(Vcb, fcb->subvol, fcb->inode, fcb->type, utf8 && utf8->Buffer[0] == '.', TRUE, Irp);
+
     if (!sd_set)
         fcb_get_sd(fcb, parent, FALSE, Irp);
-    
+
     if (fcb->type == BTRFS_TYPE_DIRECTORY && fcb->atts & FILE_ATTRIBUTE_REPARSE_POINT && fcb->reparse_xattr.Length == 0) {
         fcb->atts &= ~FILE_ATTRIBUTE_REPARSE_POINT;
-        
-        if (!Vcb->readonly && !(subvol->root_item.flags & BTRFS_SUBVOL_READONLY)) {
+
+        if (!Vcb->readonly && !is_subvol_readonly(subvol, Irp)) {
             fcb->atts_changed = TRUE;
             mark_fcb_dirty(fcb);
         }
     }
-    
+
     if (lastle)
         InsertHeadList(lastle, &fcb->list_entry);
     else
         InsertTailList(&subvol->fcbs, &fcb->list_entry);
-    
+
     InsertTailList(&Vcb->all_fcbs, &fcb->list_entry_all);
-    
+
     fcb->Header.IsFastIoPossible = fast_io_possible(fcb);
 
     *pfcb = fcb;
@@ -1245,8 +1105,8 @@
     return STATUS_SUCCESS;
 }
 
-NTSTATUS open_fcb_stream(device_extension* Vcb, root* subvol, UINT64 inode, ANSI_STRING* xattr,
-                         UINT32 streamhash, fcb* parent, fcb** pfcb, PIRP Irp) {
+static NTSTATUS open_fcb_stream(_Requires_lock_held_(_Curr_->tree_lock) _Requires_exclusive_lock_held_(_Curr_->fcb_lock) device_extension* Vcb,
+                                dir_child* dc, fcb* parent, fcb** pfcb, PIRP Irp) {
     fcb* fcb;
     UINT8* xattrdata;
     UINT16 xattrlen, overhead;
@@ -1253,234 +1113,187 @@
     NTSTATUS Status;
     KEY searchkey;
     traverse_ptr tp;
-    LIST_ENTRY* lastle = NULL;
-    
-    if (!IsListEmpty(&subvol->fcbs)) {
-        LIST_ENTRY* le = subvol->fcbs.Flink;
-                                
-        while (le != &subvol->fcbs) {
-            fcb = CONTAINING_RECORD(le, struct _fcb, list_entry);
-            
-            if (fcb->inode == inode) {
-                if (fcb->ads && fcb->adsxattr.Length == xattr->Length &&
-                    RtlCompareMemory(fcb->adsxattr.Buffer, xattr->Buffer, fcb->adsxattr.Length) == fcb->adsxattr.Length) {
-#ifdef DEBUG_FCB_REFCOUNTS
-                    LONG rc = InterlockedIncrement(&fcb->refcount);
+    static char xapref[] = "user.";
+    ANSI_STRING xattr;
+    UINT32 crc32;
 
-                    WARN("fcb %p: refcount now %i (subvol %llx, inode %llx)\n", fcb, rc, fcb->subvol->id, fcb->inode);
-#else
-                    InterlockedIncrement(&fcb->refcount);
-#endif
+    xattr.Length = (UINT16)strlen(xapref) + dc->utf8.Length;
+    xattr.MaximumLength = xattr.Length + 1;
+    xattr.Buffer = ExAllocatePoolWithTag(PagedPool, xattr.MaximumLength, ALLOC_TAG);
+    if (!xattr.Buffer) {
+        ERR("out of memory\n");
+        return STATUS_INSUFFICIENT_RESOURCES;
+    }
 
-                    *pfcb = fcb;
-                    return STATUS_SUCCESS;
-                }
-            } else if (fcb->inode > inode) {
-                lastle = le->Blink;
-                break;
-            }
-                            
-            le = le->Flink;
-        }
-    }
-    
-    fcb = create_fcb(PagedPool);
+    RtlCopyMemory(xattr.Buffer, xapref, strlen(xapref));
+    RtlCopyMemory(&xattr.Buffer[strlen(xapref)], dc->utf8.Buffer, dc->utf8.Length);
+    xattr.Buffer[xattr.Length] = 0;
+
+    fcb = create_fcb(Vcb, PagedPool);
     if (!fcb) {
         ERR("out of memory\n");
+        ExFreePool(xattr.Buffer);
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-      
-    if (!get_xattr(Vcb, parent->subvol, parent->inode, xattr->Buffer, streamhash, &xattrdata, &xattrlen, Irp)) {
+
+    fcb->Vcb = Vcb;
+
+    crc32 = calc_crc32c(0xfffffffe, (UINT8*)xattr.Buffer, xattr.Length);
+
+    if (!get_xattr(Vcb, parent->subvol, parent->inode, xattr.Buffer, crc32, &xattrdata, &xattrlen, Irp)) {
         ERR("get_xattr failed\n");
-        free_fcb(fcb);
+        free_fcb(Vcb, fcb);
+        ExFreePool(xattr.Buffer);
         return STATUS_INTERNAL_ERROR;
     }
 
-    fcb->Vcb = Vcb;
-    
     fcb->subvol = parent->subvol;
     fcb->inode = parent->inode;
     fcb->type = parent->type;
     fcb->ads = TRUE;
-    fcb->adshash = streamhash;
-    fcb->adsxattr = *xattr;
-    
+    fcb->adshash = crc32;
+    fcb->adsxattr = xattr;
+
     // find XATTR_ITEM overhead and hence calculate maximum length
-    
+
     searchkey.obj_id = parent->inode;
     searchkey.obj_type = TYPE_XATTR_ITEM;
-    searchkey.offset = streamhash;
+    searchkey.offset = crc32;
 
     Status = find_item(Vcb, parent->subvol, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("find_item returned %08x\n", Status);
-        free_fcb(fcb);
+        free_fcb(Vcb, fcb);
         return Status;
     }
-    
+
     if (keycmp(tp.item->key, searchkey)) {
         ERR("error - could not find key for xattr\n");
-        free_fcb(fcb);
+        free_fcb(Vcb, fcb);
         return STATUS_INTERNAL_ERROR;
     }
-    
+
     if (tp.item->size < xattrlen) {
         ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, xattrlen);
-        free_fcb(fcb);
+        free_fcb(Vcb, fcb);
         return STATUS_INTERNAL_ERROR;
     }
-    
+
     overhead = tp.item->size - xattrlen;
-    
+
     fcb->adsmaxlen = Vcb->superblock.node_size - sizeof(tree_header) - sizeof(leaf_node) - overhead;
-    
+
     fcb->adsdata.Buffer = (char*)xattrdata;
     fcb->adsdata.Length = fcb->adsdata.MaximumLength = xattrlen;
-    
+
     fcb->Header.IsFastIoPossible = fast_io_possible(fcb);
     fcb->Header.AllocationSize.QuadPart = xattrlen;
     fcb->Header.FileSize.QuadPart = xattrlen;
     fcb->Header.ValidDataLength.QuadPart = xattrlen;
-    
+
     TRACE("stream found: size = %x, hash = %08x\n", xattrlen, fcb->adshash);
-    
-    if (lastle)
-        InsertHeadList(lastle, &fcb->list_entry);
-    else
-        InsertTailList(&fcb->subvol->fcbs, &fcb->list_entry);
-    
+
+    InsertHeadList(&parent->list_entry, &fcb->list_entry);
+
     InsertTailList(&Vcb->all_fcbs, &fcb->list_entry_all);
-    
+
     *pfcb = fcb;
-    
+
     return STATUS_SUCCESS;
 }
 
-void insert_fileref_child(file_ref* parent, file_ref* child, BOOL do_lock) {
-    if (do_lock)
-        ExAcquireResourceExclusiveLite(&parent->nonpaged->children_lock, TRUE);
-    
-    if (IsListEmpty(&parent->children))
-        InsertTailList(&parent->children, &child->list_entry);
-    else {
-        LIST_ENTRY* le = parent->children.Flink;
-        file_ref* fr1 = CONTAINING_RECORD(le, file_ref, list_entry);
-        
-        if (child->index < fr1->index)
-            InsertHeadList(&parent->children, &child->list_entry);
-        else {
-            while (le != &parent->children) {
-                file_ref* fr2 = (le->Flink == &parent->children) ? NULL : CONTAINING_RECORD(le->Flink, file_ref, list_entry);
-                
-                if (child->index >= fr1->index && (!fr2 || fr2->index > child->index)) {
-                    InsertHeadList(&fr1->list_entry, &child->list_entry);
-                    break;
-                }
-                
-                fr1 = fr2;
-                le = le->Flink;
-            }
-        }
-    }
-    
-    if (do_lock)
-        ExReleaseResourceLite(&parent->nonpaged->children_lock);
-}
-
-static NTSTATUS open_fileref_child(device_extension* Vcb, file_ref* sf, PUNICODE_STRING name, BOOL case_sensitive, BOOL lastpart, BOOL streampart,
-                                   POOL_TYPE pooltype, file_ref** psf2, PIRP Irp) {
+NTSTATUS open_fileref_child(_Requires_lock_held_(_Curr_->tree_lock) _Requires_exclusive_lock_held_(_Curr_->fcb_lock) _In_ device_extension* Vcb,
+                            _In_ file_ref* sf, _In_ PUNICODE_STRING name, _In_ BOOL case_sensitive, _In_ BOOL lastpart, _In_ BOOL streampart,
+                            _In_ POOL_TYPE pooltype, _Out_ file_ref** psf2, _In_opt_ PIRP Irp) {
     NTSTATUS Status;
     file_ref* sf2;
-        
+
+    if (sf->fcb == Vcb->dummy_fcb)
+        return STATUS_OBJECT_NAME_NOT_FOUND;
+
     if (streampart) {
-        UNICODE_STRING streamname;
-        ANSI_STRING xattr;
-        UINT32 streamhash;
-        
-        sf2 = search_fileref_children(sf, name, case_sensitive);
-        
-        if (sf2) {
-            if (sf2->deleted) {
-                TRACE("element in path has been deleted\n");
-                free_fileref(sf2);
-                return lastpart ? STATUS_OBJECT_NAME_NOT_FOUND : STATUS_OBJECT_PATH_NOT_FOUND;
-            }
-            
-            *psf2 = sf2;
-    
-            return STATUS_SUCCESS;
-        }
-        
-        streamname.Buffer = NULL;
-        streamname.Length = streamname.MaximumLength = 0;
-        xattr.Buffer = NULL;
-        xattr.Length = xattr.MaximumLength = 0;
-        
-        // FIXME - check if already opened
-        
-        if (!find_stream(Vcb, sf->fcb, name, &streamname, &streamhash, &xattr, Irp)) {
-            TRACE("could not find stream %.*S\n", name->Length / sizeof(WCHAR), name->Buffer);
-            
-            return STATUS_OBJECT_NAME_NOT_FOUND;
-        } else {
-            fcb* fcb;
+        BOOL locked = FALSE;
+        LIST_ENTRY* le;
+        UNICODE_STRING name_uc;
+        dir_child* dc = NULL;
+        fcb* fcb;
 
-            if (streamhash == EA_DOSATTRIB_HASH && xattr.Length == strlen(EA_DOSATTRIB) &&
-                RtlCompareMemory(xattr.Buffer, EA_DOSATTRIB, xattr.Length) == xattr.Length) {
-                WARN("not allowing user.DOSATTRIB to be opened as stream\n");
-            
-                return STATUS_OBJECT_NAME_NOT_FOUND;
-            }
-            
-            Status = open_fcb_stream(Vcb, sf->fcb->subvol, sf->fcb->inode, &xattr, streamhash, sf->fcb, &fcb, Irp);
+        if (!case_sensitive) {
+            Status = RtlUpcaseUnicodeString(&name_uc, name, TRUE);
             if (!NT_SUCCESS(Status)) {
-                ERR("open_fcb_stream returned %08x\n", Status);
+                ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
                 return Status;
             }
-            
-            sf2 = create_fileref();
-            if (!sf2) {
-                ERR("out of memory\n");
-                free_fcb(fcb);
-                return STATUS_INSUFFICIENT_RESOURCES;
-            }
-            
-            sf2->fcb = fcb;
+        }
 
-            if (streamname.Buffer) // case has changed
-                sf2->filepart = streamname;
-            else {
-                sf2->filepart.MaximumLength = sf2->filepart.Length = name->Length;
-                sf2->filepart.Buffer = ExAllocatePoolWithTag(PagedPool, sf2->filepart.MaximumLength, ALLOC_TAG);
-                if (!sf2->filepart.Buffer) {
-                    ERR("out of memory\n");
-                    free_fileref(sf2);
-                    return STATUS_INSUFFICIENT_RESOURCES;
+        if (!ExIsResourceAcquiredSharedLite(&sf->fcb->nonpaged->dir_children_lock)) {
+            ExAcquireResourceSharedLite(&sf->fcb->nonpaged->dir_children_lock, TRUE);
+            locked = TRUE;
+        }
+
+        le = sf->fcb->dir_children_index.Flink;
+        while (le != &sf->fcb->dir_children_index) {
+            dir_child* dc2 = CONTAINING_RECORD(le, dir_child, list_entry_index);
+
+            if (dc2->index == 0) {
+                if ((case_sensitive && dc2->name.Length == name->Length && RtlCompareMemory(dc2->name.Buffer, name->Buffer, dc2->name.Length) == dc2->name.Length) ||
+                    (!case_sensitive && dc2->name_uc.Length == name_uc.Length && RtlCompareMemory(dc2->name_uc.Buffer, name_uc.Buffer, dc2->name_uc.Length) == dc2->name_uc.Length)
+                ) {
+                    dc = dc2;
+                    break;
                 }
-                
-                RtlCopyMemory(sf2->filepart.Buffer, name->Buffer, name->Length);
-            }
-            
-            Status = RtlUpcaseUnicodeString(&sf2->filepart_uc, &sf2->filepart, TRUE);
-            if (!NT_SUCCESS(Status)) {
-                ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
-                free_fileref(sf2);
-                return Status;
-            }
-            
-            // FIXME - make sure all functions know that ADS FCBs won't have a valid SD or INODE_ITEM
+            } else
+                break;
 
-            sf2->parent = (struct _file_ref*)sf;
-            insert_fileref_child(sf, sf2, TRUE);
-            
-            increase_fileref_refcount(sf);
+            le = le->Flink;
         }
+
+        if (!case_sensitive)
+            ExFreePool(name_uc.Buffer);
+
+        if (locked)
+            ExReleaseResourceLite(&sf->fcb->nonpaged->dir_children_lock);
+
+        if (!dc)
+            return STATUS_OBJECT_NAME_NOT_FOUND;
+
+        if (dc->fileref) {
+            increase_fileref_refcount(dc->fileref);
+            *psf2 = dc->fileref;
+            return STATUS_SUCCESS;
+        }
+
+        Status = open_fcb_stream(Vcb, dc, sf->fcb, &fcb, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("open_fcb_stream returned %08x\n", Status);
+            return Status;
+        }
+
+        sf2 = create_fileref(Vcb);
+        if (!sf2) {
+            ERR("out of memory\n");
+            free_fcb(Vcb, fcb);
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+
+        sf2->fcb = fcb;
+
+        sf2->parent = (struct _file_ref*)sf;
+
+        sf2->dc = dc;
+        dc->fileref = sf2;
+
+        ExAcquireResourceExclusiveLite(&sf->nonpaged->children_lock, TRUE);
+        InsertTailList(&sf->children, &sf2->list_entry);
+        ExReleaseResourceLite(&sf->nonpaged->children_lock);
+
+        increase_fileref_refcount(sf);
     } else {
         root* subvol;
         UINT64 inode;
         dir_child* dc;
-        
-        Status = find_file_in_dir(Vcb, name, sf->fcb, &subvol, &inode, &dc, case_sensitive, Irp);
+
+        Status = find_file_in_dir(name, sf->fcb, &subvol, &inode, &dc, case_sensitive);
         if (Status == STATUS_OBJECT_NAME_NOT_FOUND) {
             TRACE("could not find %.*S\n", name->Length / sizeof(WCHAR), name->Buffer);
 
@@ -1490,124 +1303,113 @@
             return Status;
         } else {
             fcb* fcb;
-            
+#ifdef DEBUG_STATS
+            LARGE_INTEGER time1, time2;
+#endif
+
             if (dc->fileref) {
                 if (!lastpart && dc->type != BTRFS_TYPE_DIRECTORY) {
-                    WARN("passed path including file as subdirectory\n");
+                    TRACE("passed path including file as subdirectory\n");
                     return STATUS_OBJECT_PATH_NOT_FOUND;
                 }
-                
+
                 InterlockedIncrement(&dc->fileref->refcount);
                 *psf2 = dc->fileref;
                 return STATUS_SUCCESS;
             }
-            
-            Status = open_fcb(Vcb, subvol, inode, dc->type, &dc->utf8, sf->fcb, &fcb, pooltype, Irp);
-            if (!NT_SUCCESS(Status)) {
-                ERR("open_fcb returned %08x\n", Status);
-                return Status;
+
+            if (!subvol || (subvol != Vcb->root_fileref->fcb->subvol && inode == SUBVOL_ROOT_INODE && subvol->parent != sf->fcb->subvol->id)) {
+                fcb = Vcb->dummy_fcb;
+                InterlockedIncrement(&fcb->refcount);
+            } else {
+#ifdef DEBUG_STATS
+                time1 = KeQueryPerformanceCounter(NULL);
+#endif
+                Status = open_fcb(Vcb, subvol, inode, dc->type, &dc->utf8, sf->fcb, &fcb, pooltype, Irp);
+#ifdef DEBUG_STATS
+                time2 = KeQueryPerformanceCounter(NULL);
+                Vcb->stats.open_fcb_calls++;
+                Vcb->stats.open_fcb_time += time2.QuadPart - time1.QuadPart;
+#endif
+
+                if (!NT_SUCCESS(Status)) {
+                    ERR("open_fcb returned %08x\n", Status);
+                    return Status;
+                }
             }
-            
+
             if (dc->type != BTRFS_TYPE_DIRECTORY && !lastpart && !(fcb->atts & FILE_ATTRIBUTE_REPARSE_POINT)) {
-                WARN("passed path including file as subdirectory\n");
-                free_fcb(fcb);
+                TRACE("passed path including file as subdirectory\n");
+                free_fcb(Vcb, fcb);
                 return STATUS_OBJECT_PATH_NOT_FOUND;
             }
 
-            sf2 = create_fileref();
+            sf2 = create_fileref(Vcb);
             if (!sf2) {
                 ERR("out of memory\n");
-                free_fcb(fcb);
+                free_fcb(Vcb, fcb);
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
-            
+
             sf2->fcb = fcb;
-            
+
             if (dc->type == BTRFS_TYPE_DIRECTORY)
                 fcb->fileref = sf2;
-            
-            sf2->index = dc->index;
+
             sf2->dc = dc;
             dc->fileref = sf2;
-            
-            sf2->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, dc->utf8.Length, ALLOC_TAG);
-            if (!sf2->utf8.Buffer) {
-                ERR("out of memory\n");
-                free_fileref(sf2);
-                return STATUS_INSUFFICIENT_RESOURCES;
-            }
-            
-            sf2->filepart.Buffer = ExAllocatePoolWithTag(PagedPool, dc->name.Length, ALLOC_TAG);
-            if (!sf2->filepart.Buffer) {
-                ERR("out of memory\n");
-                free_fileref(sf2);
-                return STATUS_INSUFFICIENT_RESOURCES;
-            }
-            
-            sf2->filepart_uc.Buffer = ExAllocatePoolWithTag(PagedPool, dc->name_uc.Length, ALLOC_TAG);
-            if (!sf2->filepart_uc.Buffer) {
-                ERR("out of memory\n");
-                free_fileref(sf2);
-                return STATUS_INSUFFICIENT_RESOURCES;
-            }
-            
-            sf2->utf8.Length = sf2->utf8.MaximumLength = dc->utf8.Length;
-            RtlCopyMemory(sf2->utf8.Buffer, dc->utf8.Buffer, dc->utf8.Length);
-            
-            sf2->filepart.Length = sf2->filepart.MaximumLength = dc->name.Length;
-            RtlCopyMemory(sf2->filepart.Buffer, dc->name.Buffer, dc->name.Length);
-            
-            sf2->filepart_uc.Length = sf2->filepart_uc.MaximumLength = dc->name_uc.Length;
-            RtlCopyMemory(sf2->filepart_uc.Buffer, dc->name_uc.Buffer, dc->name_uc.Length);
-            
+
             sf2->parent = (struct _file_ref*)sf;
-            
-            insert_fileref_child(sf, sf2, TRUE);
-            
+
+            ExAcquireResourceExclusiveLite(&sf->nonpaged->children_lock, TRUE);
+            InsertTailList(&sf->children, &sf2->list_entry);
+            ExReleaseResourceLite(&sf->nonpaged->children_lock);
+
             increase_fileref_refcount(sf);
         }
     }
-    
+
     *psf2 = sf2;
-    
+
     return STATUS_SUCCESS;
 }
 
-NTSTATUS open_fileref(device_extension* Vcb, file_ref** pfr, PUNICODE_STRING fnus, file_ref* related, BOOL parent, USHORT* parsed, ULONG* fn_offset,
-                      POOL_TYPE pooltype, BOOL case_sensitive, PIRP Irp) {
+NTSTATUS open_fileref(_Requires_lock_held_(_Curr_->tree_lock) _Requires_exclusive_lock_held_(_Curr_->fcb_lock) _In_ device_extension* Vcb, _Out_ file_ref** pfr,
+                      _In_ PUNICODE_STRING fnus, _In_opt_ file_ref* related, _In_ BOOL parent, _Out_opt_ USHORT* parsed, _Out_opt_ ULONG* fn_offset, _In_ POOL_TYPE pooltype,
+                      _In_ BOOL case_sensitive, _In_opt_ PIRP Irp) {
     UNICODE_STRING fnus2;
     file_ref *dir, *sf, *sf2;
-    ULONG i, num_parts;
-    UNICODE_STRING* parts = NULL;
+    LIST_ENTRY parts;
     BOOL has_stream;
     NTSTATUS Status;
-    
+    LIST_ENTRY* le;
+
     TRACE("(%p, %p, %p, %u, %p)\n", Vcb, pfr, related, parent, parsed);
 
-#ifdef DEBUG    
+#ifdef DEBUG
     if (!ExIsResourceAcquiredExclusiveLite(&Vcb->fcb_lock) && !ExIsResourceAcquiredExclusiveLite(&Vcb->tree_lock)) {
         ERR("fcb_lock not acquired exclusively\n");
         int3;
     }
 #endif
-    
+
     if (Vcb->removing || Vcb->locked)
         return STATUS_ACCESS_DENIED;
-    
+
     fnus2 = *fnus;
-    
+
     if (fnus2.Length < sizeof(WCHAR) && !related) {
         ERR("error - fnus was too short\n");
         return STATUS_INTERNAL_ERROR;
     }
-    
+
     if (related && fnus->Length == 0) {
         increase_fileref_refcount(related);
-        
+
         *pfr = related;
         return STATUS_SUCCESS;
     }
-    
+
     if (related) {
         dir = related;
     } else {
@@ -1615,178 +1417,144 @@
             ERR("error - filename %.*S did not begin with \\\n", fnus2.Length / sizeof(WCHAR), fnus2.Buffer);
             return STATUS_OBJECT_PATH_NOT_FOUND;
         }
-        
+
         if (fnus2.Length == sizeof(WCHAR)) {
-            if (Vcb->root_fileref->open_count == 0) { // don't allow root to be opened on unmounted FS
-                ULONG cc;
-                IO_STATUS_BLOCK iosb;
-                
-                Status = dev_ioctl(first_device(Vcb)->devobj, IOCTL_STORAGE_CHECK_VERIFY, NULL, 0, &cc, sizeof(ULONG), TRUE, &iosb);
-                
-                if (!NT_SUCCESS(Status))
-                    return Status;
-            }
-            
+            if (Vcb->root_fileref->open_count == 0 && !(Vcb->Vpb->Flags & VPB_MOUNTED)) // don't allow root to be opened on unmounted FS
+                return STATUS_DEVICE_NOT_READY;
+
             increase_fileref_refcount(Vcb->root_fileref);
             *pfr = Vcb->root_fileref;
-            
+
             if (fn_offset)
                 *fn_offset = 0;
-            
+
             return STATUS_SUCCESS;
         }
-        
+
         dir = Vcb->root_fileref;
-        
+
         fnus2.Buffer++;
         fnus2.Length -= sizeof(WCHAR);
         fnus2.MaximumLength -= sizeof(WCHAR);
     }
-    
+
     if (dir->fcb->type != BTRFS_TYPE_DIRECTORY && (fnus->Length < sizeof(WCHAR) || fnus->Buffer[0] != ':')) {
         WARN("passed related fileref which isn't a directory (%S) (fnus = %.*S)\n",
              file_desc_fileref(related), fnus->Length / sizeof(WCHAR), fnus->Buffer);
         return STATUS_OBJECT_PATH_NOT_FOUND;
     }
-    
-    if (fnus->Length == 0) {
-        num_parts = 0;
-    } else if (fnus->Length == wcslen(datastring) * sizeof(WCHAR) &&
-               RtlCompareMemory(fnus->Buffer, datastring, wcslen(datastring) * sizeof(WCHAR)) == wcslen(datastring) * sizeof(WCHAR)) {
-        num_parts = 0;
-    } else {
-        Status = split_path(&fnus2, &parts, &num_parts, &has_stream);
+
+    InitializeListHead(&parts);
+
+    if (fnus->Length != 0 &&
+        (fnus->Length != wcslen(datastring) * sizeof(WCHAR) || RtlCompareMemory(fnus->Buffer, datastring, wcslen(datastring) * sizeof(WCHAR)) != wcslen(datastring) * sizeof(WCHAR))) {
+        Status = split_path(Vcb, &fnus2, &parts, &has_stream);
         if (!NT_SUCCESS(Status)) {
             ERR("split_path returned %08x\n", Status);
             return Status;
         }
     }
-    
+
     sf = dir;
     increase_fileref_refcount(dir);
-    
-    if (parent) {
-        num_parts--;
-        
-        if (has_stream && num_parts > 0) {
-            num_parts--;
+
+    if (parent && !IsListEmpty(&parts)) {
+        name_bit* nb;
+
+        nb = CONTAINING_RECORD(RemoveTailList(&parts), name_bit, list_entry);
+        ExFreePool(nb);
+
+        if (has_stream && !IsListEmpty(&parts)) {
+            nb = CONTAINING_RECORD(RemoveTailList(&parts), name_bit, list_entry);
+            ExFreePool(nb);
+
             has_stream = FALSE;
         }
     }
-    
-    if (num_parts == 0) {
+
+    if (IsListEmpty(&parts)) {
         Status = STATUS_SUCCESS;
         *pfr = dir;
-        
+
         if (fn_offset)
             *fn_offset = 0;
-            
+
         goto end2;
     }
-    
-    for (i = 0; i < num_parts; i++) {
-        BOOL lastpart = (i == num_parts-1) || (i == num_parts-2 && has_stream);
-        
-        Status = open_fileref_child(Vcb, sf, &parts[i], case_sensitive, lastpart, has_stream && i == num_parts - 1, pooltype, &sf2, Irp);
+
+    le = parts.Flink;
+    do {
+        name_bit* nb = CONTAINING_RECORD(le, name_bit, list_entry);
+        BOOL lastpart = le->Flink == &parts || (has_stream && le->Flink->Flink == &parts);
+        BOOL streampart = has_stream && le->Flink == &parts;
+
+        Status = open_fileref_child(Vcb, sf, &nb->us, case_sensitive, lastpart, streampart, pooltype, &sf2, Irp);
         if (!NT_SUCCESS(Status)) {
             if (Status == STATUS_OBJECT_PATH_NOT_FOUND || Status == STATUS_OBJECT_NAME_NOT_FOUND)
                 TRACE("open_fileref_child returned %08x\n", Status);
             else
                 ERR("open_fileref_child returned %08x\n", Status);
-            
+
             goto end;
         }
-        
-        if (i == num_parts - 1) {
-            if (fn_offset)
-                *fn_offset = parts[has_stream ? (num_parts - 2) : (num_parts - 1)].Buffer - fnus->Buffer;
-            
+
+        if (le->Flink == &parts) { // last entry
+            if (fn_offset) {
+                if (has_stream)
+                    nb = CONTAINING_RECORD(le->Blink, name_bit, list_entry);
+
+                *fn_offset = (ULONG)(nb->us.Buffer - fnus->Buffer);
+            }
+
             break;
         }
-        
+
         if (sf2->fcb->atts & FILE_ATTRIBUTE_REPARSE_POINT) {
             Status = STATUS_REPARSE;
-            
-            if (parsed)
-                *parsed = (parts[i+1].Buffer - fnus->Buffer - 1) * sizeof(WCHAR);
-            
+
+            if (parsed) {
+                name_bit* nb2 = CONTAINING_RECORD(le->Flink, name_bit, list_entry);
+
+                *parsed = (USHORT)(nb2->us.Buffer - fnus->Buffer - 1) * sizeof(WCHAR);
+            }
+
             break;
         }
-        
-        free_fileref(sf);
+
+        free_fileref(Vcb, sf);
         sf = sf2;
-    }
-    
+
+        le = le->Flink;
+    } while (le != &parts);
+
     if (Status != STATUS_REPARSE)
         Status = STATUS_SUCCESS;
     *pfr = sf2;
-    
+
 end:
-    free_fileref(sf);
-    
+    free_fileref(Vcb, sf);
+
+    while (!IsListEmpty(&parts)) {
+        name_bit* nb = CONTAINING_RECORD(RemoveHeadList(&parts), name_bit, list_entry);
+        ExFreeToPagedLookasideList(&Vcb->name_bit_lookaside, nb);
+    }
+
 end2:
-    if (parts)
-        ExFreePool(parts);
-    
     TRACE("returning %08x\n", Status);
-    
+
     return Status;
 }
 
-NTSTATUS fcb_get_last_dir_index(fcb* fcb, UINT64* index, PIRP Irp) {
-    KEY searchkey;
-    traverse_ptr tp, prev_tp;
+NTSTATUS add_dir_child(fcb* fcb, UINT64 inode, BOOL subvol, PANSI_STRING utf8, PUNICODE_STRING name, UINT8 type, dir_child** pdc) {
     NTSTATUS Status;
-    
-    ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
-    
-    if (fcb->last_dir_index != 0) {
-        *index = fcb->last_dir_index;
-        fcb->last_dir_index++;
-        Status = STATUS_SUCCESS;
-        goto end;
-    }
-    
-    searchkey.obj_id = fcb->inode;
-    searchkey.obj_type = TYPE_DIR_INDEX + 1;
-    searchkey.offset = 0;
-    
-    Status = find_item(fcb->Vcb, fcb->subvol, &tp, &searchkey, FALSE, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("error - find_item returned %08x\n", Status);
-        goto end;
-    }
-    
-    if (tp.item->key.obj_id > searchkey.obj_id || (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type >= searchkey.obj_type)) {
-        if (find_prev_item(fcb->Vcb, &tp, &prev_tp, FALSE, Irp))
-            tp = prev_tp;
-    }
-    
-    if (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type == TYPE_DIR_INDEX) {
-        fcb->last_dir_index = tp.item->key.offset + 1;
-    } else
-        fcb->last_dir_index = 2;
-    
-    *index = fcb->last_dir_index;
-    fcb->last_dir_index++;
-    
-    Status = STATUS_SUCCESS;
-    
-end:
-    ExReleaseResourceLite(fcb->Header.Resource);
-    
-    return Status;
-}
+    dir_child* dc;
 
-NTSTATUS add_dir_child(fcb* fcb, UINT64 inode, BOOL subvol, UINT64 index, PANSI_STRING utf8, PUNICODE_STRING name, PUNICODE_STRING name_uc, UINT8 type, dir_child** pdc) {
-    dir_child* dc;
-    
     dc = ExAllocatePoolWithTag(PagedPool, sizeof(dir_child), ALLOC_TAG);
     if (!dc) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     dc->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, utf8->Length, ALLOC_TAG);
     if (!dc->utf8.Buffer) {
         ERR("out of memory\n");
@@ -1793,7 +1561,7 @@
         ExFreePool(dc);
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     dc->name.Buffer = ExAllocatePoolWithTag(PagedPool, name->Length, ALLOC_TAG);
     if (!dc->name.Buffer) {
         ERR("out of memory\n");
